{ Mods by Cunningham 9/9/82 or so
	 p35 has input parameter legals--a set of acceptable chars
	 conv_i_s now converts negative numbers as well }
MODULE consutil;
TYPE
  ASCII_char_set = SET OF CHAR;
PROCEDURE p35_read_and_echo_console_string(max_len:integer;var s:string
	      var legals:ASCII_char_set);
VAR
  cur_len:integer;
  ch : char;
BEGIN
  s := '';
  cur_len := 0;
  REPEAT		{ Assume max_len>=1 }
    ch := in_nech;
    if ch=cr then EXIT; { DONE }
    if ch in legals then
       begin
	 if cur_len<max_len then
	    begin
	      out_ch(ch);	       { Show it on screen }
	      cur_len := cur_len + 1;  { Count it	   }
	      s := concat(s,ch);       { Record it	   }
	      if cur_len=max_len then out_ch(bs); { Pull cursor back if
						    this one went in last
						    char posn }
	    end
       end
    else if ch=bs then
	    begin
	      if cur_len>0 then 
		 begin
		   delete(s,cur_len,1);      { Pull char out of string }
		   if cur_len<max_len then out_ch(bs);
		   out_ch(' '); out_ch(bs);  { Blank screen posn       }
		   cur_len := cur_len - 1;
		 end;
	    end;
					UNTIL false;
END;

PROCEDURE ucase(source:string; var up:string);
VAR
  l : integer;
BEGIN
  up := source; 	  { Necessary to set length byte }
  for l:= 1 to length(source) do
      if source[l] in ['a'..'z'] then up[l] := chr(ord(source[l]) & $5F)
				 else up[l] := source[l];
END;

FUNCTION ch_ucase(c:char):char;
BEGIN
  if c in ['a'..'z'] then ch_ucase := chr(ord(c) & $5F)
		     else ch_ucase := c;
END;

PROCEDURE strip_lead_blanks(var s:string);
BEGIN
  while s[1]=' ' do delete(s,1,1);
END;

PROCEDURE remove_trail_blanks(var s: string);
VAR
  p : integer;
BEGIN
  for p:= length(s) downto 0 do
      begin
	if s[p]<>' ' then exit;
	delete(s,p,1);
      end;
END;

PROCEDURE clean(source:string; var result:string);
BEGIN
  result := source;
  remove_trail_blanks(result);
  strip_lead_blanks(result);
END;

PROCEDURE conv_s_i(s:string; var i:integer; hex:Boolean;
		   var bad_char:Boolean);
VAR
  source : string;
  negate : Boolean;
BEGIN
  bad_char := false;
  i := 0;
  clean(s,source);   { Remove trailing and leading }
  u_case(source,source); { Raise to upper }
  negate := false;
  if source[1]='-' then
     begin
       negate := true;
       delete(source,1,1);
     end
  else if source[1]='+' then delete(source,1,1);
  while length(source)>0 do
    begin
      if hex then
	 begin	  { Hexidecimal case }
	   if source[1] in ['A'..'F'] then
	      i := i*16 + ord(source[1]) - ord('A') + 10
	   else if source[1] in ['0'..'9'] then
		   i := i*16 + ord(source[1]) - ord('0')
	   else bad_char := true;
	 end
      else
	 begin	   { Decimal case }
	   if source[1] in ['0'..'9'] then
	      i := i*10 + ord(source[1]) - ord('0')
	   else bad_char := true;
	 end;
      delete(source,1,1);
    end;   { while }
  if negate then i := -i;
END;

PROCEDURE conv_i_s(i:integer; var s:string; hex:Boolean);
VAR
  digit : integer;
  negate : Boolean;
BEGIN
{ No way for there to be any out of range cases here...}
  s := '';
  if i<0 then negate := true else negate := false;
  if i=0 then s:='0'
  else
    while i<>0 do
      begin
	if hex then
	  begin     { Hexidecimal case }
	   digit := i MOD 16;
	   if digit<=9 then s := concat(chr(digit+ord('0')),s)
		       else s := concat(chr(digit -10 + ord('A')),s);
	   i := i DIV 16;
	  end
	else
	   begin    { Decimal case }
	     digit := i MOD 10;
	     s := concat(chr(digit + ord('0')),s);
	     i := i DIV 10;
	   end;
      end;
  if negate then s := concat('-',s);
END;
MODEND.
at(chr(digit